<template>
  <div class="records-page" :class="{ loading }">
    <div class="page-header" v-if="!fromApp">
      <div class="page-header-photo"></div>
      <div class="page-header-message">{{ $t("records.pageTitle") }}</div>
    </div>

    <div class="container">
      <div class="hello-message" v-if="!fromApp">
        <hello-member></hello-member>
      </div>

      <div class="records">
        <div v-if="loading">
          <div class="records-tabs">
            <button class="records-tab">
              <span class="placeholder lp"></span>
            </button>
            <button class="records-tab">
              <span class="placeholder lp"></span>
            </button>
          </div>
          <records :loading="true" />
        </div>
        <div v-else>
          <div class="records-tabs">
            <button
              @click.stop.prevent="tab = 'waiting'"
              class="records-tab"
              :class="{ active: tab === 'waiting' }"
            >
              {{ $t("records.waiting.tab", { n: waitingCount }) }}
            </button>
            <button
              @click.stop.prevent="tab = 'booking'"
              class="records-tab"
              :class="{ active: tab === 'booking' }"
            >
              {{ $t("records.booking.tab", { n: bookingCount }) }}
            </button>
          </div>
          <div class="record-list">
            <records :type="tab" :reservations="displayedReservations" />
          </div>
        </div>
      </div>

      <div class="records-count">
        {{ $t("records.count", { n: displayedReservations.length }) }}
      </div>
    </div>
  </div>
</template>

<script>
import Records from "@/components/Records";
import { mapState, mapGetters } from "vuex";
import HelloMember from "@/components/HelloMember";

export default {
  data() {
    return {
      tab: "waiting"
    };
  },

  components: {
    Records,
    HelloMember
  },

  watch: {
    loading(val) {
      if (!val && !this.isLogin) {
        this.$router.push("/");
      }
    },
    account() {
      if (this.account && this.account.id) {
        this.fetch();
      }
    }
  },

  computed: {
    ...mapState("account", ["reservations", "account"]),
    ...mapGetters("account", ["isLogin"]),

    fromApp() {
      return this.account && this.account.fromApp;
    },

    waitingCount() {
      return this.filteredReservations("waiting").length;
    },

    bookingCount() {
      return this.filteredReservations("booking").length;
    },

    walkInCount() {
      return this.filteredReservations("walkIn").length;
    },

    displayedReservations() {
      return this.filteredReservations(this.tab);
    },

    loading() {
      return (
        this.$store.state.account.loading ||
        this.$store.state.account.loadingReservations
      );
    }
  },

  methods: {
    filter(typ) {
      return {
        booking: "isBooking",
        waiting: "isWaiting",
        walkIn: "isWalkIn"
      }[typ];
    },

    filteredReservations(typ) {
      const filter = this.filter(typ);
      return this.reservations.filter(r => {
        return r[filter];
      });
    },

    fetch() {
      this.$store.dispatch("account/fetchReservations");
    }
  },

  mounted() {
    if (this.account && this.account.id) {
      this.fetch();
    }
  }
};
</script>

<style lang="scss" scoped>
.page-header {
  position: relative;
  height: 120px;
  line-height: 120px;
  text-align: center;
  color: $color-white;
  background-image: url("/static/images/records-header.png");
  background-size: cover;

  &::before {
    content: "";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.3);
    z-index: 0;
  }

  @include media-breakpoint-up(md) {
    height: 240px;
    line-height: 240px;
  }
}

.hello-message {
  margin: 20px;

  @include media-breakpoint-up(md) {
    margin-left: 0;
  }
}

.records {
  margin: 0 20px;
}

.records-tabs {
  width: 100%;
  display: flex;
  align-items: center;
  flex-wrap: wrap;

  @include media-breakpoint-up(md) {
    display: block;
    margin-bottom: 10px;
  }
}

.records-tabs .records-tab {
  background: transparent;
  border: none;
  text-align: center;
  line-height: 44px;
  cursor: pointer;
  padding: 0;
  margin: 0;
  flex-grow: 1;
  position: relative;
  color: $color-secondary-black;

  &:after {
    content: "";
    width: 1px;
    height: 50%;
    background: $color-sky-grey;
    position: absolute;
    right: 0;
    top: 25%;
  }

  &:last-child:after {
    display: none;
  }

  &.active {
    color: $color-skm-red;
  }

  @include media-breakpoint-up(md) {
    display: inline-block;
    padding: 0 30px;

    &:first-child {
      padding-left: 0;
    }
  }
}

.records-count {
  text-align: center;
  font-size: 13px;
  margin: 25px 0;
  color: $color-secondary-black;
}

.records .placeholder {
  display: inline-block;
  height: 1em;
  width: 38px;
}

.page-header-message {
  position: relative;
  z-index: 1;

  @include media-breakpoint-up(md) {
    font-size: 40px;
  }
}

.records-page .record-list {
  overflow: scroll;
}
</style>
